/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.Objects;

/**
 * Transfer
 */

public class Transfer {
  @JsonProperty("comment")
  private String comment = null;

  @JsonProperty("created")
  private LocalDateTime created = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("owner")
  private Object owner = null;

  @JsonProperty("recipient")
  private Object recipient = null;

  @JsonProperty("reponse_comment")
  private String reponseComment = null;

  @JsonProperty("responded")
  private LocalDateTime responded = null;

  /**
   * The current transfer request status
   */
  public enum StatusEnum {
    PENDING("pending"),
    
    ACCEPTED("accepted"),
    
    REFUSED("refused");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  @JsonProperty("subject")
  private Object subject = null;

   /**
   * A comment about the transfer request
   * @return comment
  **/
  @ApiModelProperty(value = "A comment about the transfer request")
  public String getComment() {
    return comment;
  }

   /**
   * The transfer request date
   * @return created
  **/
  @ApiModelProperty(value = "The transfer request date")
  public LocalDateTime getCreated() {
    return created;
  }

   /**
   * The transfer unique identifier
   * @return id
  **/
  @ApiModelProperty(value = "The transfer unique identifier")
  public String getId() {
    return id;
  }

  public Transfer owner(Object owner) {
    this.owner = owner;
    return this;
  }

   /**
   * The user or organization currently owning the transfered object
   * @return owner
  **/
  @ApiModelProperty(value = "The user or organization currently owning the transfered object")
  public Object getOwner() {
    return owner;
  }

  public void setOwner(Object owner) {
    this.owner = owner;
  }

  public Transfer recipient(Object recipient) {
    this.recipient = recipient;
    return this;
  }

   /**
   * The user or organization receiving the transfered object
   * @return recipient
  **/
  @ApiModelProperty(value = "The user or organization receiving the transfered object")
  public Object getRecipient() {
    return recipient;
  }

  public void setRecipient(Object recipient) {
    this.recipient = recipient;
  }

   /**
   * A comment about the transfer response
   * @return reponseComment
  **/
  @ApiModelProperty(value = "A comment about the transfer response")
  public String getReponseComment() {
    return reponseComment;
  }

   /**
   * The transfer response date
   * @return responded
  **/
  @ApiModelProperty(value = "The transfer response date")
  public LocalDateTime getResponded() {
    return responded;
  }

  public Transfer status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * The current transfer request status
   * @return status
  **/
  @ApiModelProperty(example = "pending", value = "The current transfer request status")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public Transfer subject(Object subject) {
    this.subject = subject;
    return this;
  }

   /**
   * The transfered object
   * @return subject
  **/
  @ApiModelProperty(value = "The transfered object")
  public Object getSubject() {
    return subject;
  }

  public void setSubject(Object subject) {
    this.subject = subject;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Transfer transfer = (Transfer) o;
    return Objects.equals(this.comment, transfer.comment) &&
        Objects.equals(this.created, transfer.created) &&
        Objects.equals(this.id, transfer.id) &&
        Objects.equals(this.owner, transfer.owner) &&
        Objects.equals(this.recipient, transfer.recipient) &&
        Objects.equals(this.reponseComment, transfer.reponseComment) &&
        Objects.equals(this.responded, transfer.responded) &&
        Objects.equals(this.status, transfer.status) &&
        Objects.equals(this.subject, transfer.subject);
  }

  @Override
  public int hashCode() {
    return Objects.hash(comment, created, id, owner, recipient, reponseComment, responded, status, subject);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Transfer {\n");

    sb.append("    comment: ").append(toIndentedString(comment)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    owner: ").append(toIndentedString(owner)).append("\n");
    sb.append("    recipient: ").append(toIndentedString(recipient)).append("\n");
    sb.append("    reponseComment: ").append(toIndentedString(reponseComment)).append("\n");
    sb.append("    responded: ").append(toIndentedString(responded)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    subject: ").append(toIndentedString(subject)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

